import jcfw from './jcfw'
import g from '../common/global'

let jcshare = jcfw.share;

let SDKManage = function () {
  this.isoffical = g.env === 'product';
  this.gameId = 8005;
  this.hasLogin = false;
  this.vision = '1.0.0';
  this.ChannelId = 6001;
  this.mpCode = '';
  this.init = function (launchObj) {
    this.launchObj = launchObj;
    jcfw.init(this.ChannelId, this.gameId, this.isoffical, launchObj);
  };
  this.updateMpCode = function (mpCode) {
    this.mpCode = mpCode;
  };
  this.login = async function (cb) {
    await this.gameLogin();
    await this.checkShareData();
    // redis 配置
    await this.getGameConfig();
    // 获取分享配置
    await this.getShareConfig();
  };
  this.gameLogin = () => {
    let self = this;
    let loginCount = 0;
    return new Promise((resolve, reject) => {
      let login = () => {
        let token = wx.getStorageSync('token');
        if (!token) {
          token = jcfw.makeUUID();
          try {
            wx.setStorageSync('token', token);
          } catch (e) {
          }
        }
        jcfw.loginUser((res) => {
          self.hasLogin = true;
          console.log('login success', res);
          wx.setStorageSync('account', res);
          self.account_id = res.account_id;
          resolve();
        },
          (neterr, logicerr, errmsg) => {
            if (loginCount++ < 10) {
              login();
            } else {
              reject();
            }
          },
          self.mpCode
        );
      };
      login();
    });
  };
  this.checkShareData = function () {
    return new Promise((resolve, reject) => {
      let ldata;
      if (this.launchObj) {
        ldata = this.launchObj.query;
      } else {
        ldata = wx.getLaunchOptionsSync().query;
      }
      if (ldata.inviter_id) {
        jcshare.acceptAchievementInvite(ldata.inviter_id, '100', JSON.stringify([['100', 100]]));
      }
      resolve();
    });


  };

  this.getGameConfig = function () {
    let tryCount = 0;
    return new Promise((resolve, reject) => {
      let cb = function (res) {
        console.log('getGameConfig', res);
        wx.setStorageSync('cfg', res);
        resolve();
      };
      let cbf = function (res) {
        console.log('getGameConfig fail');
        if (tryCount++ < 10) {
          request();
        } else {
          reject();
        }
      };
      let request = () => {
        jcfw.cloud.initConfig(cb, cbf);
      };
      request();
    });
  };


  this.setStorage = function (v, successcb, failcb) {
    if (this.hasLogin) {
      jcfw.cloud.setStorages(v, successcb, failcb);
    }
  };
  this.getStorage = function (keys, successcb, failcb) {
    if (this.hasLogin) {
      jcfw.cloud.getStorages(keys, successcb, failcb);
    }
  };

  this.getShareConfig = function () {
    let tryCount = 0;
    return new Promise((resolve, reject) => {
      let cbs = function (res) {
        if (res.length > 0) {
          let shareArr = [];
          for (let obj of res) {
            shareArr.push({
              image: obj.image,
              str: obj.str
            });
          }
          wx.setStorageSync('share_cfg', shareArr);
        }
        console.log('getShareConfig success', res);
        resolve();
      };
      let cbf = function () {
        console.log('getShareConfig fail');
        if (tryCount++ < 10) {
          request();
        } else {
          reject();
        }
      };
      let request = () => {
        jcfw.cloud.getShareData(this.sex, this.province, this.city, cbs, cbf);
      };
      request();
    });
  };

  this.getAchievInviteeNum = function () {
    return new Promise((resolve, reject) => {
      const callback = function (res) {
        console.log('playerData.invitee_nums');
        console.log(res);
        let invitee_nums = 0;
        for (let i = 0; i < res.length; i++) {
          if (res[i].achievement_id === 100) {
            invitee_nums = res[i].invitee_num;//邀请玩家数
            break;
          }
        }
        resolve(invitee_nums);
      };
      jcshare.getAchievInviteeNum(callback, (err) => {
        reject(err);
      });
    });
  };


  this.queryAchievementShareDetail = function () {
    return new Promise((resolve, reject) => {
      const callback = function (res) {
        const result = res[100] || [];
        resolve(result);
      };
      jcshare.queryAchievementShareDetail([100], callback, function () {
        reject();
      });
    });
  };
  this.updateUser = function (allInfo) {
    return new Promise((resolve, reject) => {
      jcfw.updateUser(allInfo, (obj) => {
        resolve(obj);
      }, (err) => {
        reject(err);
      });
    });
  };
  this.uploadLog = function (eventName, param) {
    jcfw.gamelog.logButtonClick(eventName, param);
  };
};


let instance = new SDKManage();
export default instance;
