/**
 * Created by y.x on 18/09/06.
 */

export default {
    set: function(key, value){
        try{
            wx.setStorageSync(key,value);
            return true;
        }catch(err){
            console.log(err);
        }
        return false;
    },

    get: function(key){
        return  wx.getStorageSync(key);        
    },
    setjson: function(key, value){
        this.set(key,JSON.stringify(value));
    },
    getjson:function(key){
        let str = this.get(key);
        if(str){
            try{
                return JSON.parse(str);
            }catch(err){
            }
        }
        return null;    
    },
    remove: function(key){
        wx.removeStorageSync(key);        
    },

    hasItem: function(key){
        var result =  wx.getStorageSync(key);
        if(result == '' && typeof(result) != 'number'){
            return false;
        }
        return true;
    },

    setData: function(key,value){
        var data = {};
        data[key] = value;
        console.log("storage====set== " + JSON.stringify(data));
        return this.set(key, JSON.stringify(data));
    },

    getStringData: function(key){
		console.log("storage====get== start" + key);
        var result = wx.getStorageSync(key);
        if (!result)
        {
    	    return "0";
        }
        var data = null;
        try{
            data = JSON.parse(result);
        }catch(err){
            console.log(err);
        }

        console.log("storage====get== " + data);
        if(!data){
            return "0";
        }
        console.log("storage====get== " + data[key]);
        return data[key];
    },

    setStorage: function(skey, svalue, successcb, failcb, timeorign_type, time_value){
        var bok = this.set(skey, svalue);
        if(bok){
            successcb && successcb();
        }else{
            failcb && failcb(-1, 0, 'storage kev/value failed!k/v:'+skey+'/'+svalue);
        }
    },

    setStorages: function(kvlist, successcb, failcb){
        let bok = true;
        kvlist.forEach(element => {
            if(!this.set(element.key, element.value)){
                bok = false;
            }
        });
        if(bok){
            successcb && successcb();
        }else{
            failcb && failcb(-1, 0, 'storage kvlist failed!'+JSON.stringify(kvlist));
        }
    },

    getStorage: function(key, successcb, failcb){
        let value = this.get(key);
        successcb && successcb(value);
    },

    getStorages: function(keylist, successcb, failcb){
        let lst = [];
        keylist.forEach(element => {
            let v = this.get(element);
            lst.push({
                key: element,
                value: v,
            });
        });
        successcb && successcb(lst);
    },
};