// const baseUrl = 'http://localhost:2333/api/open/maker'
const baseUrl = 'https://mp.kingsome.cn/api/open/maker'
// const baseUrl = 'https://mp-test.kingsome.cn/api/open/maker'

export default {
    getData(path, params) {
        return new Promise((resolve, reject) => {
            wx.request({
                url: baseUrl + path,
                data: params,
                method: 'GET',
                header: {
                    'content-type': 'application/json'
                },
                success(res) {
                    const data = res.data
                    if (data.errcode !== 0) {
                        reject(data)
                        return
                    }
                    resolve(data)
                },
                fail(err) {
                    reject(err)
                }
            })
        })
    },
    postData(path, data) {
        return new Promise((resolve, reject) => {
            wx.request({
                url: baseUrl + path,
                data: data,
                method: 'POST',
                header: {
                    'content-type': 'application/json'
                },
                success(res) {
                    const data = res.data
                    if (data.errcode !== 0) {
                        reject(data)
                        return
                    }
                    resolve(data)
                },
                fail(err) {
                    reject(err)
                }
            })
        })
    }
}